package skins
{
   import flash.display.Graphics;
   import mx.core.EdgeMetrics;
   import mx.core.IUIComponent;
   import mx.core.mx_internal;
   import mx.graphics.RectangularDropShadow;
   import mx.skins.RectangularBorder;
   
   use namespace mx_internal;
   
   public class SimpleTwoColorBorder extends RectangularBorder
   {
      private var dropShadow:RectangularDropShadow;
      
      mx_internal var backgroundColor:Object;
      
      protected var _borderMetrics:EdgeMetrics;
      
      mx_internal var backgroundAlphaName:String;
      
      public function SimpleTwoColorBorder()
      {
         super();
      }
      
      mx_internal function getBackgroundColor() : Object
      {
         var _loc2_:Object = null;
         var _loc1_:IUIComponent = parent as IUIComponent;
         if(Boolean(_loc1_) && !_loc1_.enabled)
         {
            _loc2_ = getStyle("backgroundDisabledColor");
            if(_loc2_)
            {
               return _loc2_;
            }
         }
         return getStyle("backgroundColor");
      }
      
      override public function styleChanged(param1:String) : void
      {
         if(param1 == null || param1 == "styleName" || param1 == "borderStyle" || param1 == "borderThickness")
         {
            this._borderMetrics = null;
         }
         invalidateDisplayList();
      }
      
      mx_internal function getBackgroundColorMetrics() : EdgeMetrics
      {
         return this.borderMetrics;
      }
      
      override protected function updateDisplayList(param1:Number, param2:Number) : void
      {
         if(isNaN(param1) || isNaN(param2))
         {
            return;
         }
         super.updateDisplayList(param1,param2);
         this.mx_internal::backgroundColor = this.mx_internal::getBackgroundColor();
         this.mx_internal::backgroundAlphaName = "backgroundAlpha";
         this.mx_internal::drawBorder(param1,param2);
         this.mx_internal::drawBackground(param1,param2);
         this.mx_internal::drawDropShadow(0,0,param1,param2,0,0,0,0);
      }
      
      mx_internal function getDropShadowAngle(param1:Number, param2:String) : Number
      {
         if(param2 == "left")
         {
            return param1 >= 0 ? 135 : 225;
         }
         if(param2 == "right")
         {
            return param1 >= 0 ? 45 : 315;
         }
         return param1 >= 0 ? 90 : 270;
      }
      
      override public function get borderMetrics() : EdgeMetrics
      {
         if(this._borderMetrics)
         {
            return this._borderMetrics;
         }
         var _loc1_:Number = getStyle("borderThickness");
         this._borderMetrics = new EdgeMetrics(_loc1_,_loc1_,_loc1_,_loc1_);
         return this._borderMetrics;
      }
      
      mx_internal function drawBackground(param1:Number, param2:Number) : void
      {
         var _loc3_:Number = NaN;
         var _loc4_:Number = NaN;
         var _loc5_:EdgeMetrics = null;
         var _loc6_:Graphics = null;
         if(this.mx_internal::backgroundColor !== null && this.mx_internal::backgroundColor !== "" || getStyle("mouseShield") || getStyle("mouseShieldChildren"))
         {
            _loc3_ = Number(this.mx_internal::backgroundColor);
            _loc4_ = 1;
            _loc5_ = this.mx_internal::getBackgroundColorMetrics();
            _loc6_ = graphics;
            if(isNaN(_loc3_) || this.mx_internal::backgroundColor === "" || this.mx_internal::backgroundColor === null)
            {
               _loc4_ = 0;
               _loc3_ = 16777215;
            }
            else
            {
               _loc4_ = getStyle(this.mx_internal::backgroundAlphaName);
            }
            _loc6_.beginFill(_loc3_,_loc4_);
            _loc6_.drawRect(_loc5_.left,_loc5_.top,param1 - _loc5_.right - _loc5_.left,param2 - _loc5_.bottom - _loc5_.top);
            _loc6_.endFill();
         }
      }
      
      mx_internal function drawDropShadow(param1:Number, param2:Number, param3:Number, param4:Number, param5:Number, param6:Number, param7:Number, param8:Number) : void
      {
         var _loc11_:Number = NaN;
         if(getStyle("dropShadowEnabled") == false || getStyle("dropShadowEnabled") == "false" || param3 == 0 || param4 == 0)
         {
            return;
         }
         var _loc9_:Number = getStyle("shadowDistance");
         var _loc10_:String = getStyle("shadowDirection");
         _loc11_ = this.mx_internal::getDropShadowAngle(_loc9_,_loc10_);
         _loc9_ = Math.abs(_loc9_) + 2;
         if(!this.dropShadow)
         {
            this.dropShadow = new RectangularDropShadow();
         }
         this.dropShadow.distance = _loc9_;
         this.dropShadow.angle = _loc11_;
         this.dropShadow.color = getStyle("dropShadowColor");
         this.dropShadow.alpha = 0.4;
         this.dropShadow.tlRadius = param5;
         this.dropShadow.trRadius = param6;
         this.dropShadow.blRadius = param8;
         this.dropShadow.brRadius = param7;
         this.dropShadow.drawShadow(graphics,param1,param2,param3,param4);
      }
      
      mx_internal function drawBorder(param1:Number, param2:Number) : void
      {
         var _loc8_:Number = NaN;
         var _loc3_:int = getStyle("borderColor");
         var _loc4_:int = getStyle("outerBorderColor");
         var _loc5_:Number = getStyle("borderThickness");
         var _loc6_:String = getStyle("borderStyle");
         var _loc7_:Graphics = graphics;
         _loc7_.clear();
         if(_loc6_ == "none")
         {
            return;
         }
         if(_loc5_ <= 1 || isNaN(_loc4_))
         {
            _loc7_.beginFill(_loc3_);
            _loc7_.drawRect(0,0,param1,param2);
            _loc7_.endFill();
         }
         else
         {
            _loc8_ = Math.floor(_loc5_ / 2);
            _loc7_.beginFill(_loc4_);
            _loc7_.drawRect(0,0,param1,param2);
            _loc7_.endFill();
            _loc7_.beginFill(_loc3_);
            _loc7_.drawRect(_loc8_,_loc8_,param1 - 2 * _loc8_,param2 - 2 * _loc8_);
            _loc7_.endFill();
         }
      }
   }
}

